/* 
Copyright  2003-5  
   Dean E. Dauger, Dauger Research, Inc. 
   http://daugerresearch.com/
*/

#ifndef __poochjobexecute

#define __poochjobexecute


int executepoochlaunch(JobOptionsPtr oP)
	{int out=0; 
	if (oP) {
		int i;
#define o			(oP[0])
		
		if (o.proceed) 
			{
			if (o.numFileArgs<1) {
				printf("No files supplied.\n"); 
				o.proceed=0; 
				}
			
			if ((o.numNodeArgs<1)&&!o.waitForUserToLaunch) {
				printf("No node information supplied.\n"); 
				o.proceed=0; 
				}
				
			if (o.proceed) {//write out the AppleScript(s) and run them
				FILE *fp=fopen("/tmp/tempScript", "w"); 
				if (fp) {
					rewind(fp); 
					fprintf(fp, "tell application \"Pooch App\"\n"); 
					fprintf(fp, " activate\n"); 
					fprintf(fp, " set j to make new job\n"); 
					fprintf(fp, "end tell\n"); 
					fclose(fp); 
					}
				
				if (o.testMode) 
					out=system("cat /tmp/tempScript"); 
				else {
					char *reply=NULL; 
					char *scriptstr=readfromfile("/tmp/tempScript"); 
					if (scriptstr) 
						reply=callosascriptpoochportd(scriptstr); 
					if (reply) {
						free(reply); 
						reply=NULL; 
						}
					else //it didn't work, so poochportd might not be running
						out=system("osascript -s s /tmp/tempScript"); //try it the old way
					}
				
/* only because it seems to be highly inconvenient to convert POSIX paths to AppleScript file refs from here*/
				for(i=0; i<o.numFileArgs; i++) {
					char openstr[512], *fullpathstr; short scriptMade=0; 
				//	sprintf(openstr, "open -a \"Pooch App\" %s", o.fileArgs[i]); 
					strcpy(openstr, "open -a /Applications/Pooch/\"Pooch App\" "); 
					fullpathstr=getfullpathstr(o.fileArgs[i], o.pathContext); 
					
					if (fullpathstr) {
						fp=fopen("/tmp/tempScript", "w"); 
						if (fp) {
							rewind(fp); 
							fprintf(fp, "set fullpath to \"%s\"\n", fullpathstr); 
							fprintf(fp, "set thefile to POSIX file fullpath\n"); 
							fprintf(fp, "tell application \"Pooch App\"\n"); 
							fprintf(fp, " open thefile\n"); 
							fprintf(fp, " open fullpath\n"); /* try every which way */
							fprintf(fp, "end tell\n"); 
							fclose(fp); 
							scriptMade=1; 
							}
					
						strcat(openstr, fullpathstr); 
						free(fullpathstr); 
						}
					else {
						if (o.pathContext) strcat(openstr, o.pathContext); 
						strcat(openstr, o.fileArgs[i]); 
						}
					
					if (o.testMode) {
						printf(strcat(openstr, "\n")); 
						if (scriptMade) 
							out=system("cat /tmp/tempScript"); 
						}
					else {
						if (poochopenthis(o.fileArgs[i], o.pathContext))
							; 
						else 
							out=system(openstr); 
						
						if (scriptMade) {
							char *reply=NULL; 
							char *scriptstr=readfromfile("/tmp/tempScript"); 
							if (scriptstr) 
								reply=callosascriptpoochportd(scriptstr); 
							if (reply) {
								free(reply); 
								reply=NULL; 
								}
							else //it didn't work, so poochportd might not be running
								out=system("osascript -s s /tmp/tempScript"); //try it the old way
							}
						}
					
					}
				
				fp=fopen("/tmp/tempScript", "w"); 
				if (fp) {
					fprintf(fp, "with timeout of 15 seconds\ntell application \"Pooch App\"\n"); 
					fprintf(fp, " set j to first job\n"); 
/*					
					for(i=0; i<numFileArgs; i++) {
						fprintf(fp, " make new file at j with data alias \"%s\"\n", argv[fileArgs[i]]); 
						}
*/					
					if (o.noSelfOption) 
						fprintf(fp, " delete the node list -- at j\n"); /*clear it*/
					
					if (o.numNodeArgs>0) 
						{int nodeCount=0; 
						sscanf(o.nodeArgs[0], "%d", &nodeCount); 
						i=strlen(o.nodeArgs[0]); 
						while (i--) {
							char c=o.nodeArgs[0][i]; 
							if ((c<'0')||(c>'9')) /* if any part of it is not a number */
								nodeCount=0; /* then it's an address */
							}
						if (nodeCount) {
							printf("Scanning for nodes...\n"); 
							if (o.numProcessorOption) {
								fprintf(fp, " make new node at j with properties (node scan for best processors %d)\n", nodeCount); 
								fprintf(fp, " delete node %d of j\n", nodeCount+1); 
								/* trim to correct processor count */
								fprintf(fp, " set numProcessorsRequired to %d\n", nodeCount); 
								fprintf(fp, " set nl to nodelist of j\n"); 
								fprintf(fp, " set processorCount to 0\n"); 
								fprintf(fp, " repeat with i from 1 to (count of nl)\n"); 
								
								fprintf(fp, "  if (processorCount >= numProcessorsRequired) then\n"); 
								fprintf(fp, "   repeat with ii from (count of nl) to i by -1\n"); 
								fprintf(fp, "    delete node ii of j\n"); 
								fprintf(fp, "   end repeat\n"); 
								fprintf(fp, "   exit repeat\n"); 
								fprintf(fp, "  end if\n"); 
								
								fprintf(fp, "  set processorCount to processorCount + (number of processors of (item i of nl))\n"); 
								
								fprintf(fp, " end repeat\n"); 
								
								if (1==nodeCount) // -np 1 case: only use one processor
									fprintf(fp, " set tasks per computer of j to 1\n"); 
								//needs later version of Pooch for -np odd general case
								}
							else {
								fprintf(fp, " make new node at j with properties (node scan for best %d)\n", nodeCount); 
								fprintf(fp, " delete node %d of j\n", nodeCount+1); 
								}
							}
						else {
							for(i=0; i<o.numNodeArgs; i++) {
								fprintf(fp, " make new node at j with properties {name:\"%s\", address:\"%s\"}\n", o.nodeArgs[i], o.nodeArgs[i]); 
								}
							}
						}
					//job options generally added in this fashion
					if (o.skipBusyCheck) 
						fprintf(fp, " set BUSY check of j to no\n"); 
					if (o.launchFailureQueuesJob) 
						fprintf(fp, " set launch failure queues job of j to yes\n"); 
					if (o.subDirArg) 
						fprintf(fp, " set target subfolder of j to \"%s\"\n", o.subDirArg); 
					
					switch (o.tcpPort) {
						case 0: 
							break; 
						default: 
							fprintf(fp, " set port number of j to %u\n", o.tcpPort); 
							break; 
							}
					
					switch (o.jobType) {
						case 4: 
							fprintf(fp, " set job type of j to lam\n"); 
							break; 
						case 3: 
							fprintf(fp, " set job type of j to mpichgm\n"); 
							break; 
						case 2: 
							fprintf(fp, " set job type of j to MPIPro\n"); 
							break; 
						default: 
						case 0: 
							fprintf(fp, " set job type of j to MacMPI\n"); 
							break; 
						case 1: 
							fprintf(fp, " set job type of j to mpich\n"); 
							break; 
							}
					
					switch (o.autoRetrieve) {
						case 3: 
							fprintf(fp, " set retrieve output of j to all nodes\n"); 
							break; 
						case 1: 
							fprintf(fp, " set retrieve output of j to off\n"); 
							break; 
						default: 
						case 0: 
						case 2: 
							fprintf(fp, " set retrieve output of j to node 0\n"); 
							break; 
							}
					
					if ((o.tasksPerComputer>0)&&(o.tasksPerComputer<=16)) 
						fprintf(fp, " set tasks per computer of j to %d \n", o.tasksPerComputer); 
					else
						fprintf(fp, " set tasks per computer of j to default\n"); 
					
					{char *loginname; 
				/*	getpwuid(geteuid())? */
					if (loginname=getlogin()) 
						fprintf(fp, " set user name of j to \"%s\"\n", loginname); 
					}
					
					if (o.numExtraArgs>0) {
						char extraCLAs[256]={'\0'}; 
						
						for(i=0; i<o.numExtraArgs; i++) {
							if (i) strcat(extraCLAs, " "); 
							strcat(extraCLAs, o.extraArgs[i]); 
							}
						
						fprintf(fp, " set Unix arguments of j to \"%s\"\n", extraCLAs); 
						
						}
					
					if (!o.noSelfOption) {
						if (!o.waitForUserToLaunch) 
						if (!access(o.fileArgs[0], X_OK)) switch (o.jobType) {
							case 0: case 1: 
								{//can be executed
								fprintf(fp, " set node zero skip of j to enabled\n"); 
								o.iAmLaunching=1; 
								}
								break; 
							default: 
								break;
								}
						}
					
					if (!o.waitForUserToLaunch) 
						fprintf(fp, " launch j\n"); 
					
					fprintf(fp, "end tell\nend timeout\n"); 
					
					out=fclose(fp); 
					}
				
				/*see the man pages on osacompile, osascript*/
				if (o.testMode) 
					out=system("cat /tmp/tempScript"); 
				else {
					char *reply=NULL; 
					char *scriptstr=readfromfile("/tmp/tempScript"); 
					if (scriptstr) 
						reply=callosascriptpoochportd(scriptstr); 
					if (reply) {
						free(reply); 
						reply=NULL; 
						}
					else //it didn't work, so poochportd might not be running
						out=system("osascript -s s /tmp/tempScript"); //try it the old way
					}
				if (!o.saveScript) remove("/tmp/tempScript"); 
				
				/* I think it's polite to clean up after myself */
				if (o.jobFileFlag) {
					free(o.jobFileData); 
					o.jobFileData=NULL; 
					//free(o.argv); 
					}
				
				if (!out) if (!o.testMode) if (o.iAmLaunching) {
					if (o.numFileArgs>0) {
						char launchstr[256]; 
						short needsDotSlash=0; 
						short looping=60; 
						
						printf("Stand by for launch...\n"); 
						while (looping-->0) {
							sleep(2); 
							
							fp=fopen("temp2Script", "w"); 
							if (fp) {char answerS[256]; 
								fprintf(fp, "tell application \"Pooch App\"\n"); 
								fprintf(fp, " get launching a parallel job\n"); 
								fprintf(fp, "end tell\n"); 
								
								out=fclose(fp); 
								fp=NULL; 
								
								{char *reply=NULL; 
								char *scriptstr=readfromfile("temp2Script"); 
								if (scriptstr) 
									reply=callosascriptpoochportd(scriptstr); 
								if (reply) {
									writetofile("answer.txt", reply); 
									free(reply); 
									reply=NULL; 
									}
								else //it didn't work, so poochportd might not be running
									out=system("osascript temp2Script >> answer.txt"); 
								}
								remove("temp2Script"); 
								
								fp=fopen("answer.txt", "r"); 
								if (fp) {
									fscanf(fp, "%s", answerS); 
									fclose(fp); 
									if (!strcmp(answerS, "no")) 
										looping=0; 
									if (!strcmp(answerS, "disabled")) 
										looping=0; 
									}
								
								remove("answer.txt"); 
								}
							
							if (looping) 
								printf("Please stand by...\n"); 
							
							}
						
						if (!strchr(o.fileArgs[0], '/')) 
							needsDotSlash=1; 
						sprintf(launchstr, needsDotSlash?"./%s":"%s", o.fileArgs[0]); 
						if (o.numExtraArgs>0) {
							char extraCLAs[256]={'\0'}; 
							
							for(i=0; i<o.numExtraArgs; i++) {
								strcat(extraCLAs, " "); 
								strcat(extraCLAs, o.extraArgs[i]); 
								}
							strcat(launchstr, extraCLAs); 
							}
						printf("Launching task #0...\n"); 
						out=system(launchstr); 
						}
					}
				
				}
			
			}
		
#undef o
   		}
	return out; 
	}

#endif
