/* 
Copyright  2003-5  
   Dauger Research, Inc. 
   http://daugerresearch.com/
*/

#ifndef __poochnodescan

#define __poochnodescan

#include "poochnodescan.h"

#define NameKeyword			"name:"
#define AddressKeyword		"address:"
#define RatingKeyword		"rating:"
#define OSVersionKeyword	"OS version:"
#define LoadKeyword			"load:"
#define StatusKeyword			"status:"
#define FreeMemKeyword		"free memory:"
#define AchievedPerfKeyword		"achieved performance:"
#define NumProcessorsKeyword	"number of processors:"
#define ClockSpeedKeyword		"processor clock speed:"
#define FreeDiskSpaceKeyword	"free disk space:"
#define ProcessorTypeKeyword	"processor type:"
#define PhysicalMemoryKeyword	"physical memory:"
#define TimeStampKeyword	"time stamp:"

/* 
There is nothing particularly clever or fancy about this method of parsing, 
but it works.
*/

char *strkw(char *s, char *kw); 
char *strkw(char *s, char *kw)
	{char *out; 
	out=strstr(s, kw); 
	if (out) {
		char *startBracket=strchr(s, '{'), *endBracket=strchr(s, '}'); 
		while (out&&endBracket&&(endBracket<out)) {
			if (!startBracket) 
				out=NULL; 
			else if (startBracket>=endBracket) 
				out=NULL; 
			else {int nest; 
				startBracket=strchr(startBracket+1, '{'); 
				if (!startBracket) 
					endBracket=strchr(endBracket+1, '}'); 
				else for(nest=1; nest&&startBracket&&endBracket; ) {
					if (startBracket<endBracket) {
						nest++; 
						startBracket=strchr(startBracket+1, '{'); 
						}
					else {
						nest--; 
						endBracket=strchr(endBracket+1, '}'); 
						}
					}
				if (endBracket) 
					startBracket=strchr(endBracket+1, '{'); 
				
				}
			}
		}
	return out; 
	}
	
void parsefield(char *buffer, char *tp); 
void parsefield(char *buffer, char *tp)
	{
	if (buffer) if (tp) {
		char *nextColon, *nextComma; 
		nextColon=strchr(tp, ':'); 
		nextComma=strchr(tp, ','); 
		if (!nextComma) nextComma=strchr(tp, '}'); 
		
		if (nextColon&&nextComma) {
			if ('\"'==nextColon[1]) nextColon++; 
			if ('}'==nextComma[-1]) nextComma--; 
			if ('\"'==nextComma[-1]) nextComma--; 
			strncpy(buffer, nextColon+1, nextComma-nextColon-1); 
			buffer[nextComma-nextColon-1]=0; 
			} 
		else
			buffer[0]=0; 
		}
	else 
		buffer[0]=0; 
		
	}

void parsedatefield(char *buffer, char *tp, long flags); 
void parsedatefield(char *buffer, char *tp, long flags)
	{
	if (buffer) if (tp) {
		char *nextColon, *nextComma; 
		nextColon=strstr(tp, ":date \""); 
		if (nextColon) nextColon=strchr(nextColon, '\"'); 
		if (nextColon) nextComma=strchr(nextColon+1, '\"'); 
		
		if (nextColon&&nextComma) {
			if ('\"'==nextColon[1]) nextColon++; 
			if ('}'==nextComma[-1]) nextComma--; 
			if ('\"'==nextComma[-1]) nextComma--; 
			strncpy(buffer, nextColon+1, nextComma-nextColon-1); 
			buffer[nextComma-nextColon-1]=0; 
			if (flags) {
				char dow[12], month[12], time[8], ampm[4]; 
				unsigned int year, day; 
				//eliminate stray commas
				nextComma=strchr(buffer, ','); 
				if (nextComma) {
					nextComma[0]=' '; 
					nextComma=strchr(nextComma, ','); 
					if (nextComma) 
						nextComma[0]=' '; 
					}
				sscanf(buffer, "%s %s %u %u %s %s", dow, month, &day, &year, time, ampm); 
				month[3]=0; 
				nextColon=strchr(time, ':'); 
				if (nextColon) {
					nextColon=strchr(nextColon+1, ':'); 
					nextColon[0]=0; 
					}
				ampm[1]=0; 
				sprintf(buffer, "%-2.2u%-3s%-2.2u %s%-1s", day, month, year%100, time, ampm); 
				}
			} 
		else
			buffer[0]=0; 
		}
	else 
		buffer[0]=0; 
		
	}

#define BufferSize			1024L
void parseNodeScan(char *dataP, OptionsPtr oP); 
void parseNodeScan(char *dataP, OptionsPtr oP)
	{
	if (dataP) if (oP->proceed) {
		char buffer[BufferSize], *tp, *dataEnd; 
		long nodeCount=0; 
		
		dataEnd=strstr(dataP, "}}"); 
		
		if (!dataEnd) //data incomplete???
			dataEnd=dataP+strlen(dataP); 
		
		for(tp=strstr(dataP, NameKeyword); tp&&(tp<dataEnd); tp=strstr(tp+1, NameKeyword)) 
			nodeCount++; 
		
		printf(oP->wideMode?
"Name                     Stat IPAddress        Load     ClSp AchvPerf OSVers #P FrMm Rating   FreeDisk   PhyMem ProcType\n"
:
"Name           Stat IPAddress    Load     ClSp AchvPerf OSVers #P FrMm Rating\n"
); 
		//printf("node count %d\n", nodeCount); 
		
		oP->numAvailableNodes=0; 
		oP->availableNodeList=(NodeExtendedPtr)malloc(nodeCount*sizeof(NodeExtendedStruct)); 
		if (oP->availableNodeList) {
			long i=nodeCount*sizeof(NodeExtendedStruct)>>2, *tp=(long*)oP->availableNodeList; 
			while(i--) tp[i]=0; //clear it
			}
		
		for(tp=strstr(dataP, NameKeyword); tp&&(tp<dataEnd); tp=strstr(tp+1, NameKeyword)) {
			NodeExtendedPtr nodeP=&oP->availableNodeList[oP->numAvailableNodes]; 
			char *kw; 
			nodeCount++; 
			
			kw=tp; 
			parsefield(buffer, kw); 
			strcpy(nodeP->name, buffer); 
		if (oP->wideMode) {
			buffer[24]=0; 
			printf("%-24s", buffer); 
			}
		else {
			buffer[14]=0; 
			printf("%-14s", buffer); 
			}
			
			kw=strstr(tp, StatusKeyword); 
			parsefield(buffer, kw); 
			buffer[4]=0; 
			printf(" %-4s", buffer); 
			
			if (!strcasecmp(buffer, "BUSY")) 
				nodeP->flags|=busyFlag; 
			
			kw=strstr(tp, AddressKeyword); 
			parsefield(buffer, kw); 
			
			strcpy(nodeP->address, buffer); 
			
		if (oP->wideMode) {
			buffer[16]=0; 
			printf(" %-16s", buffer); 
			}
		else {
			buffer[12]=0; 
			printf(" %-12s", buffer); 
			}
			
			kw=strstr(tp, LoadKeyword); 
			parsefield(buffer, kw); 
			sscanf(buffer, "%f", &nodeP->load); 
			 
			buffer[8]=0; 
			printf(" %-8s", buffer); 
			
			kw=strstr(tp, ClockSpeedKeyword); 
			parsefield(buffer, kw); 
			sscanf(buffer, "%ld", &nodeP->clockSpeed); 
			
			buffer[4]=0; 
			printf(" %-4s", buffer); 
			
			kw=strstr(tp, AchievedPerfKeyword); 
			parsefield(buffer, kw); 
			sscanf(buffer, "%f", &nodeP->achievedPerf); 
			buffer[8]=0; 
			printf(" %-8s", buffer); 
			
			kw=strstr(tp, OSVersionKeyword); 
			parsefield(buffer, kw); 
			{double td; 
			sscanf(buffer, "%g", &td); 
			nodeP->osVersion=100.0*td; 
			}
			buffer[6]=0; 
			printf(" %-6s", buffer); 
			
			kw=strstr(tp, NumProcessorsKeyword); 
			parsefield(buffer, kw); 
			sscanf(buffer, "%ld", &nodeP->numProcessors); 
			buffer[2]=0; 
			printf(" %-2s", buffer); 
			
			kw=strstr(tp, FreeMemKeyword); 
			parsefield(buffer, kw); 
			sscanf(buffer, "%ld", &nodeP->freeMem); 
			buffer[4]=0; 
			printf(" %-4s", buffer); 
			
			kw=strstr(tp, RatingKeyword); 
			parsefield(buffer, kw); 
			sscanf(buffer, "%f", &nodeP->rating); 
			buffer[8]=0; 
			printf(" %-8s", buffer); 
			
			if (oP->wideMode) {
				kw=strstr(tp, FreeDiskSpaceKeyword); 
				parsefield(buffer, kw); 
				buffer[10]=0; 
				printf(" %-10s", buffer); 
				
				kw=strstr(tp, PhysicalMemoryKeyword); 
				parsefield(buffer, kw); 
				buffer[6]=0; 
				printf(" %-6s", buffer); 
				
				kw=strstr(tp, ProcessorTypeKeyword); 
				parsefield(buffer, kw); 
				buffer[10]=0; 
				printf(" %-10s", buffer); 
				
				/*
				kw=strstr(tp, TimeStampKeyword); 
				parsefield(buffer, kw); 
				printf(" %s", buffer); 
				*/
				
				}
			
			printf("\n"); 
			
			if (!(TrimNodesFlag&oP->flags)) 
				oP->numAvailableNodes++; 
			else {
				
			if (!(busyFlag&nodeP->flags)) //count this one if not BUSY
				if (nodeP->rating>1) //if rating is greater than 1
					if (nodeP->load<0.80) //if load is lesser than 80%
						oP->numAvailableNodes++; 
				}
			
			
			}
		
		}
	
	}

#define StateKeyword		"state:"
#define JobIDKeyword	"job id:"
#define PIDKeyword		"process id:"
#define ElapsedTimeKeyword			"elapsed time:"
#define JobTypeKeyword			"job type:"
#define TPCKeyword		"tasks per computer:"
#define QueueJobKeyword		"queues job:"
#define BUSYCheckKeyword	"BUSY check:"
#define AcquireNodesKeyword		"automatically acquire nodes:"
#define NodeCountKeyword	"node count:"
#define FileCountKeyword	"file count:"
#define NodeAcquireCountKeyword	"node acquire count:"
#define OriginNameKeyword	"origin:{name:"
#define SubmitTimeKeyword	"submission time:"
#define StartTimeKeyword	"start time:"
#define EndTimeKeyword	"end time:"

void parseJobScan(char *dataP, OptionsPtr oP); 
void parseJobScan(char *dataP, OptionsPtr oP)
	{
	if (dataP) if (oP->proceed) {
		char buffer[BufferSize], *tp, *dataEnd; 
		long jobCount=0; 
		
		dataEnd=strstr(dataP, "}}"); 
		
		if (!dataEnd) //data incomplete???
			dataEnd=dataP+strlen(dataP); 
		
		for(tp=strstr(dataP, NameKeyword); tp&&(tp<dataEnd); ) {
			char *tp2; 
			jobCount++; 
			tp2=strstr(tp+1, OriginNameKeyword); 
			if (tp2) tp=strstr(tp2+1, NameKeyword); 
			tp=strstr(tp+1, NameKeyword); 
			}
		
		printf(oP->wideMode?
"Name                           State   NdsFlsJobType  ElpsdTm JobID      PID   Submission Tm  Start Time     End Time   \n"
:
"Name                    State   NdsFlsJobType  ElpsdTm JobID      Submitted Tm\n"
); 
		//printf("node count %d\n", nodeCount); 
		
		oP->numJobs=0; 
		
		for(tp=strkw(dataP, NameKeyword); tp&&(tp<dataEnd); ) {
			char *kw, *tp2; 
			jobCount++; 
			
			kw=tp; 
			parsefield(buffer, kw); 
		if (oP->wideMode) {
			buffer[30]=0; 
			printf("%-30s", buffer); 
			}
		else {
			buffer[23]=0; 
			printf("%-23s", buffer); 
			}
			
			kw=strkw(tp, StateKeyword); 
			parsefield(buffer, kw); 
			buffer[7]=0; 
			printf(" %-7s", buffer); 
			
			kw=strkw(tp, NodeCountKeyword); 
			if (!kw) strkw(tp, NodeAcquireCountKeyword); 
			parsefield(buffer, kw); 
			 
			buffer[3]=0; 
			printf(" %-3s", buffer); 
			
			kw=strkw(tp, FileCountKeyword); 
			parsefield(buffer, kw); 
			
			buffer[3]=0; 
			printf("%-3s", buffer); 
			
			kw=strkw(tp, JobTypeKeyword); 
			parsefield(buffer, kw); 
			buffer[8]=0; 
			printf("%-8s", buffer); 
			
			kw=strkw(tp, ElapsedTimeKeyword); 
			parsefield(buffer, kw); 
			buffer[7]=0; 
			printf(" %-7s", buffer); 
			
			kw=strkw(tp, JobIDKeyword); 
			parsefield(buffer, kw); 
			buffer[14]=0; 
			{char *Ep=strchr(buffer, 'E'), *dotp=strchr(buffer, '.'); 
			if (!Ep) Ep=strchr(buffer, 'e'); 
			if (Ep&&dotp) if (Ep>dotp) {
				while (dotp<Ep) {
					dotp[0]=dotp[1]; 
					dotp++; 
					}
				Ep[-1]=0; 
				}
			}
			printf(" %-10s", buffer); 
			
		if (oP->wideMode) {
			kw=strkw(tp, PIDKeyword); 
			parsefield(buffer, kw); 
			buffer[5]=0; 
			printf(" %-5s", buffer); 
			}
			
			kw=strkw(tp, SubmitTimeKeyword); 
			parsedatefield(buffer, kw, 1); 
			buffer[14]=0; 
			printf(" %-14s", buffer); 
			
			if (oP->wideMode) {
			kw=strkw(tp, StartTimeKeyword); 
			parsedatefield(buffer, kw, 1); 
			buffer[14]=0; 
			printf(" %-14s", buffer); 
			
			kw=strkw(tp, EndTimeKeyword); 
			parsedatefield(buffer, kw, 1); 
			buffer[14]=0; 
			printf(" %-14s", buffer); 
			
				}
			
			printf("\n"); 
			
			oP->numJobs++; 
			
			tp2=strstr(tp+1, OriginNameKeyword); 
			if (tp2) tp=strstr(tp2+1, NameKeyword); 
			tp=strstr(tp+1, NameKeyword); 
			
			}
		
		}
	
	}

#endif
